<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: melon::AnnParser Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('classmelon_1_1_ann_parser.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classmelon_1_1_ann_parser-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">melon::AnnParser Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div></div>
</div><!--header-->
<div class="contents">

<p>This class implements an abstract parent class for ANN file parser.  
 <a href="#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_ann_parser_8h_source.html">AnnParser.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for melon::AnnParser:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classmelon_1_1_ann_parser.png" usemap="#melon::AnnParser_map" alt=""/>
  <map id="melon::AnnParser_map" name="melon::AnnParser_map">
<area href="classmelon_1_1_model_parser.html" title="This class is a abstract parent class for model parser implemented in the MeLOn library." alt="melon::ModelParser" shape="rect" coords="72,0,206,24"/>
<area href="classmelon_1_1_ann_parser_csv.html" title="This class implements an specialization of the AnnParser for csv files." alt="melon::AnnParserCsv" shape="rect" coords="0,112,134,136"/>
<area href="classmelon_1_1_ann_parser_xml.html" title="This class implements an specialization of the AnnParser for xml files." alt="melon::AnnParserXml" shape="rect" coords="144,112,278,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-methods" name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad55c71474bb6154af7a8b4696ababdea" id="r_ad55c71474bb6154af7a8b4696ababdea"><td class="memItemLeft" align="right" valign="top">virtual std::shared_ptr&lt; <a class="el" href="struct_model_data.html">ModelData</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#ad55c71474bb6154af7a8b4696ababdea">parse_model</a> (const std::string modelPath, const std::string modelName)=0</td></tr>
<tr class="memdesc:ad55c71474bb6154af7a8b4696ababdea"><td class="mdescLeft">&#160;</td><td class="mdescRight">Abstract function for defining the structure of the parsing function which is used to get the ANN data from a file.  <br /></td></tr>
<tr class="separator:ad55c71474bb6154af7a8b4696ababdea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classmelon_1_1_model_parser"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pub_methods_classmelon_1_1_model_parser')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classmelon_1_1_model_parser.html">melon::ModelParser</a></td></tr>
<tr class="memitem:a1797eba4c97ed24dcb60b874c1d59bde inherit pub_methods_classmelon_1_1_model_parser" id="r_a1797eba4c97ed24dcb60b874c1d59bde"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html#a1797eba4c97ed24dcb60b874c1d59bde">~ModelParser</a> ()=default</td></tr>
<tr class="memdesc:a1797eba4c97ed24dcb60b874c1d59bde inherit pub_methods_classmelon_1_1_model_parser"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual desctructor to enable inheritance.  <br /></td></tr>
<tr class="separator:a1797eba4c97ed24dcb60b874c1d59bde inherit pub_methods_classmelon_1_1_model_parser"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pro-methods" name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a3c68338943ed45fc0415214743a9260a" id="r_a3c68338943ed45fc0415214743a9260a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespacemelon.html#a48f12885945641a41597e6668940dc73">ACTIVATION_FUNCTION</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a3c68338943ed45fc0415214743a9260a">_string_to_activation_function</a> (const std::string &amp;activationFunctionName)</td></tr>
<tr class="memdesc:a3c68338943ed45fc0415214743a9260a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Turns a string containing the name of an activation function in the correct enum representation.  <br /></td></tr>
<tr class="separator:a3c68338943ed45fc0415214743a9260a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classmelon_1_1_model_parser"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pro_methods_classmelon_1_1_model_parser')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classmelon_1_1_model_parser.html">melon::ModelParser</a></td></tr>
<tr class="memitem:a38cba45beb94be7372469315f017576c inherit pro_methods_classmelon_1_1_model_parser" id="r_a38cba45beb94be7372469315f017576c"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html#a38cba45beb94be7372469315f017576c">_format_file_path</a> (const std::string modelPath, const std::string modelName, const <a class="el" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType)</td></tr>
<tr class="memdesc:a38cba45beb94be7372469315f017576c inherit pro_methods_classmelon_1_1_model_parser"><td class="mdescLeft">&#160;</td><td class="mdescRight">Applies the correct format to the path given by the user.  <br /></td></tr>
<tr class="separator:a38cba45beb94be7372469315f017576c inherit pro_methods_classmelon_1_1_model_parser"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2631bf777f02fa3deefa3391affedf0b inherit pro_methods_classmelon_1_1_model_parser" id="r_a2631bf777f02fa3deefa3391affedf0b"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html#a2631bf777f02fa3deefa3391affedf0b">_format_folder_path</a> (const std::string modelPath)</td></tr>
<tr class="memdesc:a2631bf777f02fa3deefa3391affedf0b inherit pro_methods_classmelon_1_1_model_parser"><td class="mdescLeft">&#160;</td><td class="mdescRight">Applies the correct format to the path given by the user.  <br /></td></tr>
<tr class="separator:a2631bf777f02fa3deefa3391affedf0b inherit pro_methods_classmelon_1_1_model_parser"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="inherited" name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_static_methods_classmelon_1_1_model_parser"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pro_static_methods_classmelon_1_1_model_parser')"><img src="closed.png" alt="-"/>&#160;Static Protected Member Functions inherited from <a class="el" href="classmelon_1_1_model_parser.html">melon::ModelParser</a></td></tr>
<tr class="memitem:a079c906eccf340590701dba8d6a776d9 inherit pro_static_methods_classmelon_1_1_model_parser" id="r_a079c906eccf340590701dba8d6a776d9"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespacemelon.html#a7ee65995944832d7b450202201d45c11">SCALER_TYPE</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html#a079c906eccf340590701dba8d6a776d9">_string_to_scaler_type</a> (const std::string scalerTypeName)</td></tr>
<tr class="memdesc:a079c906eccf340590701dba8d6a776d9 inherit pro_static_methods_classmelon_1_1_model_parser"><td class="mdescLeft">&#160;</td><td class="mdescRight">Turns a string containing the name of an scaler type in the correct enum representation.  <br /></td></tr>
<tr class="separator:a079c906eccf340590701dba8d6a776d9 inherit pro_static_methods_classmelon_1_1_model_parser"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2a5a119986e39a4f951d9952e5d209e inherit pro_static_methods_classmelon_1_1_model_parser" id="r_ab2a5a119986e39a4f951d9952e5d209e"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespacemelon.html#a7c96133788161408370e83766fc229ce">SCALER_PARAMETER</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html#ab2a5a119986e39a4f951d9952e5d209e">_string_to_scaler_parameter</a> (const std::string scalerParameterName)</td></tr>
<tr class="memdesc:ab2a5a119986e39a4f951d9952e5d209e inherit pro_static_methods_classmelon_1_1_model_parser"><td class="mdescLeft">&#160;</td><td class="mdescRight">Turns a string containing the name of an scaler type in the correct enum representation.  <br /></td></tr>
<tr class="separator:ab2a5a119986e39a4f951d9952e5d209e inherit pro_static_methods_classmelon_1_1_model_parser"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classmelon_1_1_model_parser"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pro_attribs_classmelon_1_1_model_parser')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classmelon_1_1_model_parser.html">melon::ModelParser</a></td></tr>
<tr class="memitem:a1be76f5606faa2afdad693f26dd1660a inherit pro_attribs_classmelon_1_1_model_parser" id="r_a1be76f5606faa2afdad693f26dd1660a"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html#a1be76f5606faa2afdad693f26dd1660a">_modelPath</a></td></tr>
<tr class="separator:a1be76f5606faa2afdad693f26dd1660a inherit pro_attribs_classmelon_1_1_model_parser"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7d5473b675b9595aee8db5f44a5a2c1 inherit pro_attribs_classmelon_1_1_model_parser" id="r_ac7d5473b675b9595aee8db5f44a5a2c1"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html#ac7d5473b675b9595aee8db5f44a5a2c1">_modelName</a></td></tr>
<tr class="separator:ac7d5473b675b9595aee8db5f44a5a2c1 inherit pro_attribs_classmelon_1_1_model_parser"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements an abstract parent class for ANN file parser. </p>
<p>This abstarct class is used to define a general interface for ANN fileparsers. Child classes can implement the defined interface functions according to their filetype. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a3c68338943ed45fc0415214743a9260a" name="a3c68338943ed45fc0415214743a9260a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3c68338943ed45fc0415214743a9260a">&#9670;&#160;</a></span>_string_to_activation_function()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespacemelon.html#a48f12885945641a41597e6668940dc73">ACTIVATION_FUNCTION</a> AnnParser::_string_to_activation_function </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;</td>          <td class="paramname"><span class="paramname"><em>activationFunctionName</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Turns a string containing the name of an activation function in the correct enum representation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">activationFunctionName</td><td>is a string containing the name of an activation function</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the enum representation of the input </dd></dl>

</div>
</div>
<a id="ad55c71474bb6154af7a8b4696ababdea" name="ad55c71474bb6154af7a8b4696ababdea"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad55c71474bb6154af7a8b4696ababdea">&#9670;&#160;</a></span>parse_model()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::shared_ptr&lt; <a class="el" href="struct_model_data.html">ModelData</a> &gt; melon::AnnParser::parse_model </td>
          <td>(</td>
          <td class="paramtype">const std::string</td>          <td class="paramname"><span class="paramname"><em>modelPath</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string</td>          <td class="paramname"><span class="paramname"><em>modelName</em></span>&#160;)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Abstract function for defining the structure of the parsing function which is used to get the ANN data from a file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">modelPath</td><td>Path to the location of the ANN file</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">modelName</td><td>name of the network (either foldername in which csv files are stored or name of an xml file, depending on the filetype)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns <a class="el" href="struct_model_data.html" title="Abstract class from which specific model data object can be derived and enabling polymorphism.">ModelData</a> struct containing the information defining the ANN </dd></dl>

<p>Implements <a class="el" href="classmelon_1_1_model_parser.html#ac7d0b1a14fcfe2a609487c402d7edb3f">melon::ModelParser</a>.</p>

<p>Implemented in <a class="el" href="classmelon_1_1_ann_parser_csv.html#ab0348883fd88c5c6b498f26301a33a49">melon::AnnParserCsv</a>, and <a class="el" href="classmelon_1_1_ann_parser_xml.html#ace18e736a1ae5e2af87aa15de2c318af">melon::AnnParserXml</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>C:/Data/Git/MeLOn/feedforward neural network/model/inc/<a class="el" href="_ann_parser_8h_source.html">AnnParser.h</a></li>
<li>C:/Data/Git/MeLOn/feedforward neural network/model/src/<a class="el" href="_ann_parser_8cpp.html">AnnParser.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacemelon.html">melon</a></li><li class="navelem"><a class="el" href="classmelon_1_1_ann_parser.html">AnnParser</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
